#include "q.h"

#define NEXT(i) (((i)+1)%QSIZE)

int nmsg;

Message*
message(char *data, int len)
{
	Message *m;
	m = emalloc9p(sizeof(Message)+len);
	m->ref = 1;
	m->len = len;
	memmove(m+1, data, len);
nmsg++;
	return m;
}

Message*
releasemsg(Message *m)
{
	if(decref(m) == 0){
		free(m);
nmsg--;
		return nil;
	}
	return m;
}

Reader*
newreader(Queue *q)
{
	Reader *r;

print("making reader\n");
	r = emalloc9p(sizeof(Reader));
	r->q = q;
	r->next = q->rd;
	q->rd = r;
	r->pos = q->wr;
	r->offset = 0;
	r->rq = nil;
	return r;
}

Message*
getmsg(Reader *r)
{
	Message *m;
	if(r->pos < 0 || r->pos == r->q->wr)
		return nil;
	m = r->q->data[r->pos];
	r->pos = NEXT(r->pos);
	return m;
}

Message*
peekmsg(Reader *r)
{
	if(r->pos < 0 || r->pos == r->q->wr)
		return nil;
	return r->q->data[r->pos];
}

void
removereader(Queue *q, Reader *r)
{
	Reader **rp;
	Message *m;
	for(rp = &q->rd; *rp; rp = &(*rp)->next)
		if(*rp == r){
			while(m = getmsg(r))
				releasemsg(m);
			*rp = r->next;
			r->next = nil;
			r->q = nil;
			r->pos = -1;
			return;
		}
}

void
addmsg(Queue *q, char *data, int len)
{
	Reader **rp, *r;
	Message *m;
	int nx;

	m = message(data, len);
	nx = NEXT(q->wr);
	/* If a reader is lagging, set to inactive */
	for(rp = &q->rd; *rp; rp = &(*rp)->next)
		if((*rp)->pos == nx)
			(*rp)->pos = -1;
	/* add a ref for every active reader; add to queue if there are readers */
	for(r = q->rd; r; r = r->next)
		if(r->pos >= 0)
			incref(m);
	m = releasemsg(m);
	if(m){
		q->data[q->wr] = m;
		q->wr = nx;
	}
}

/*
void
addmsgf(Queue *q, char *fmt, ...)
{
	char *s;
	va_list args;
	va_start(args, fmt);
	s = vsmprint(fmt, args);
	va_end(args);
	addmsg(q, s, strlen(s)+1);
}


void
printq(Reader *r)
{
	Message *m;
	while(m = getmsg(r)){
		print("%s\n", (char*)(m+1));
		releasemsg(m);
	}
}

void
main()
{
	Queue q;
	Reader *r1, *r2;
	Message *m;
	int i, j;

	q.wr = 0;
	r1 = newreader(&q);
	r2 = newreader(&q);

	for(i = 0; i < 60; i += 10)
		addmsgf(&q, "hello %d", i);
	for(j = 0; j < 4; j++)
		if(m = getmsg(r1), m)
			releasemsg(m);
	for(; i < 130; i += 10)
		addmsgf(&q, "yo %d", i);

	printq(r1);
	print("\n");
	printq(r2);

	print("nmsg: %d\n", nmsg);

	exits(nil);
}
*/
